import java.io.*;
import java.util.*;

public class billboard{
	
	static public int sizex;
	static public int sizey;

	static class Board implements Comparable {
		
		Board() {
			int t;
			for (t=0;t<8;t++) {
				p[t] = 0;
			}
		}

		Board(Board b) {
			int t;
			for (t=0;t<8;t++) {
				p[t] = b.p[t];
			}
		}

		int index(int x, int y) {
			return x + sizex * y;
		}

		void put(int x, int y) {
			int i = index(x,y);
			int b = i/32;
			int pos = i % 32;
			int z = 1 << pos;
			p[b] = p[b] | z;
		}

		void reset(int x, int y) {
			int i = index(x,y);
			int b = i/32;
			int pos = i % 32;
			int z;
			z = ~(1 << pos);
			p[b] &= z;
		}
		
		void revert(int x, int y) {
			boolean v = get(x,y);
			if (v) reset(x,y);
				else
				put(x,y);
		}

		void action(int x, int y) {
			revert(x,y);
			if (x > 0) 
				revert(x-1,y);
			if (y > 0) 
				revert(x,y-1);
			if (x < sizex-1) 
				revert(x+1,y);
			if (y < sizey-1) 
				revert(x,y+1);


		}

		boolean get(int x, int y) {
			int i = index(x,y);
			int b = i/32;
			int pos = i % 32;
			int z = 1 << pos;
			return (p[b] & z) != 0;
		}

		boolean equals(Board b) 
		{
			int t;
			for (t=0;t<8;t++) {
				if (b.p[t] != this.p[t])  {
					return false;
				}
			}
			return true;
		}

		public int compareTo(Object o) {
			Board b = (Board) o;
			int t;
			for (t=0;t<8;t++) {
				int d = b.p[t] - this.p[t];
				if (d != 0)  {
					return d;
				}
			}
			return 0;
		
		}

		public void ppp() {
			int s,t;
			for (t = 0; t < sizey; t++) {
				for (s = 0; s < sizex; s++) {
					if (get(s,t)) {
						System.out.print("+");
					}
					else {
						System.out.print(".");
					}
				}
				System.out.println("");
			}

			System.out.println("");
		}

		int [] p = new int[8];
	}

	public static void main(String[] args){
		BufferedReader in  = new BufferedReader(new InputStreamReader(System.in));
		String str = "";
		while(true){
			try{
				Board start = new Board();
				str = in.readLine();
				String[] v = str.split(" ");
				sizex = Integer.parseInt(v[0]);
				sizey = Integer.parseInt(v[1]);

				if (sizex == 0)
					return;

				int t,s;


				for (t=0;t<sizex;t++) {
					String r = in.readLine();
					System.out.println(r);
					for (s=0;s<sizey;s++) {
						if (r.charAt(s) != '.') {
							start.put(t,s);
						}
					}
				}

				start.put(0,0);
				start.put(2,3);
				start.ppp();
				
				if (start.get(1,1))
					System.out.println("Y");
				
				Queue<Board> q = new LinkedList();
				Queue<Board> nq = new LinkedList();
				TreeSet<Board> tset = new TreeSet();

				q.offer(start);
				tset.add(start);
				int steps = 0;
				Board init = new Board();
				while(q.peek() != null) {
					Board b = q.poll();
					if (b.equals(init)) {
						break;
					}
					int k,l;
					for (k=0;k<sizex;k++)
						for(l=0;l<sizey;l++) {
							Board bb = new Board(b);
							bb.action(k,l);
							if (tset.contains(bb))
								continue;
							nq.add(bb);
							tset.add(bb);

						}
					if (q.peek() == null) {
						q = nq;
						nq = new LinkedList();
						steps ++;
					}
					System.out.println(steps + " " + tset.size());
				}
				System.out.println("STEPS = "+steps);
				
	/*			String[] strs = s.split(" ");
				if(strs[0].startsWith("from")){
					int base = Integer.parseInt(strs[0].substring(5));
					System.out.println("base = " + base);
					int n = 0;
					for(int i = 0; i < strs[1].length(); i++){
						Integer.parseInt(strs[1].charAt(strs[1].length()-i))
						if()
					}			
				}*/
			} catch(IOException e) {
				System.out.println(e.getMessage());
			}
		}
		
	}
}
